//Two Player
#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>

RF24 radio(9, 8);  // CE, CSN

//address through which two modules communicate.
const byte address[6] = "00001"; //Note the receiver and transmitter should have the same address.


unsigned long leftMillisnow = 0; 
unsigned long rightMillisnow = 0; 
unsigned long pedalMillisnow = 0;

unsigned long leftMillisbefore = 0; 
unsigned long rightMillisbefore = 0; 
unsigned long pedalMillisbefore = 0;
 
const long interval = 300;      


struct Data_Package {
  uint16_t deviceno = 0;
  uint16_t distance = 0;
  float ax = 0;
  float ay = 0;
  float az = 0;
  float asqrt = 0;  
};

Data_Package data;

float leftthreshold = 0.5;
float rightthreshold = -0.5;

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);

  pinMode(4, OUTPUT);
  digitalWrite(4, HIGH);
  pinMode(5, OUTPUT);
  digitalWrite(5, HIGH);
  pinMode(6, OUTPUT);
  digitalWrite(6, HIGH);

  if (!radio.begin()) {
   Serial.println(F("radio hardware is not responding!!"));
   while (1) {} // hold in infinite loop
  }
  radio.openReadingPipe(0, address);
  radio.setPALevel(RF24_PA_MAX);
  radio.startListening();  //Set module as receiver
  
}

void loop() {

  
  if (radio.available()) {
    radio.read(&data, sizeof(Data_Package));
    if (data.deviceno == 1);
      
      Serial.println("Distance: " + String(data.distance));
      if (data.distance < 35 & data.distance != 0 ){
        pedalMillisnow = millis();
        data.distance = 0;
        digitalWrite(6, LOW);
        Serial.println("Pedal Button Pressed");
      }
    }
    if (data.deviceno == 2){
        //Serial.println("accelX: " + String(data.ax));
        //Serial.println("accelY: " + String(data.ay));
        //Serial.println("accelZ: " + String(data.az)); 
        if (data.az > leftthreshold){
          Serial.println("Right Button Pressed");
          leftMillisnow = millis();
          digitalWrite(5, LOW);
        }
        if(data.az < rightthreshold){
          Serial.println("Left Button Pressed");
          rightMillisnow = millis();
          digitalWrite(4, LOW);
        }
        
      }

    if (pedalMillisnow - pedalMillisbefore >= interval){
      pedalMillisbefore = pedalMillisnow;
      digitalWrite(6, HIGH);
      Serial.println("Pedal Button Released");
    }
    if (leftMillisnow - leftMillisbefore >= interval){
      leftMillisbefore = leftMillisnow;
      Serial.println("Right Button Released");
      data.az = 0;
      digitalWrite(5, HIGH);
    }
    if (rightMillisnow - rightMillisbefore >= interval){
      rightMillisbefore = rightMillisnow;
      Serial.println("Left Button Released");
      data.az = 0;
      digitalWrite(4, HIGH);
    }
    delay(10);
                                                                                                                                                                                                                                                                                                                                         
}
